<script setup lang="ts">
import { onMounted, ref } from "vue";
import { Modal } from "bootstrap";
import BootstrapModal from "@/components/modals/BootstrapModal.vue";

const props = defineProps<{
  modalId: string;
  objectNameDelete?: string;
  backModalId?: string;
}>();

const confirmDelete = ref<boolean>(false);
const emit = defineEmits<{
  (e: "confirm-delete"): void;
}>();

let deleteModal: Modal | null = null;
const randomIDSuffix = Math.random().toString(16).substring(2, 8);

function modalClosed() {
  confirmDelete.value = false;
}

function deleteObject() {
  emit("confirm-delete");
  deleteModal?.hide();
  confirmDelete.value = false;
}

onMounted(() => {
  deleteModal = Modal.getOrCreateInstance("#" + props.modalId);
});
</script>

<template>
  <bootstrap-modal
    :modalId="props.modalId"
    :static-backdrop="true"
    modal-label="Confirm Delete Modal"
    v-on="{ 'hidden.bs.modal': modalClosed }"
  >
    <template v-slot:header> Delete {{ props.objectNameDelete }}</template>
    <template v-slot:body>
      <p>
        Are you sure you want to delete
        <strong v-if="props.objectNameDelete">{{
          props.objectNameDelete
        }}</strong>
      </p>
      <div class="form-check">
        <input
          class="form-check-input"
          type="checkbox"
          v-model="confirmDelete"
          :id="'checkConfirmDelete' + randomIDSuffix"
        />
        <label
          class="form-check-label"
          :for="'checkConfirmDelete' + randomIDSuffix"
        >
          <strong>Yes</strong>, I am sure.
        </label>
      </div>
    </template>
    <template v-slot:footer>
      <button
        v-if="backModalId"
        type="button"
        class="btn btn-secondary"
        :data-bs-target="'#' + props.backModalId"
        data-bs-toggle="modal"
      >
        Back
      </button>
      <button
        v-else
        type="button"
        class="btn btn-secondary"
        data-bs-dismiss="modal"
      >
        Close
      </button>
      <button
        type="button"
        class="btn btn-danger"
        :disabled="!confirmDelete"
        @click="deleteObject"
      >
        Delete
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
